using System;
using System.Web;
using System.Data;
using System.Data.SqlClient;
using System.Collections.Generic;
using System.Configuration;
using System.Web.Profile;
using System.Text;
using System.Xml.Serialization;

/// <summary>
/// Summary description for FavoriteComics
/// </summary>
public class FavoriteComics
{
	[XmlIgnore] // Don't want this field serialized!
	public static readonly DataSet EmptyDataSet = GetEmptyDataSet ();

	public List<int> _Favorites = new List<int> ();

	public void AddComic (int id)
	{
		_Favorites.Add (id);
	}

	public void RemoveComic(int id)
	{
		_Favorites.Remove (id);
	}

	public bool IsInFavoritesList (int id)
	{
		return _Favorites.IndexOf (id) != -1;
	}

	public DataSet GetFavorites ()
	{
		if (_Favorites.Count == 0)
			return EmptyDataSet;

		// Build a SELECT statement containing an IN clause
		StringBuilder builder = new StringBuilder ("SELECT ComicID, Title, Number, Year, Grade, CGC, BookValue, CoverImage FROM Comics WHERE ComicID IN (");

		foreach (int id in _Favorites)
		{
			builder.Append (id.ToString());
			builder.Append (',');
		}

		builder.Remove (builder.Length - 1, 1); // Remove the final comma
		builder.Append (")");                   // Add a closing paren

		// Execute the SELECT statement
		SqlConnection connection = new SqlConnection (ConfigurationManager.ConnectionStrings["MyComicsConnectionString"].ConnectionString);
		SqlCommand command = new SqlCommand (builder.ToString (), connection);
		SqlDataAdapter adapter = new SqlDataAdapter (command);
		DataSet ds = new DataSet ();
		adapter.Fill (ds);
		return ds;
	}

	static DataSet GetEmptyDataSet ()
	{
		SqlConnection connection = new SqlConnection (ConfigurationManager.ConnectionStrings["MyComicsConnectionString"].ConnectionString);
		SqlCommand command = new SqlCommand ("SELECT ComicID, Title, Number, Year, Grade, CGC, BookValue, CoverImage FROM Comics", connection);
		SqlDataAdapter adapter = new SqlDataAdapter (command);
		DataSet ds = new DataSet ();
		adapter.FillSchema (ds, SchemaType.Source);
		return ds;
	}
}

public class FavoriteComicsDB
{
	public DataSet Select ()
	{
		FavoriteComics favorites = (FavoriteComics) HttpContext.Current.Profile["Favorites"];
        if (favorites == null)
            return FavoriteComics.EmptyDataSet;
		return favorites.GetFavorites ();
	}

	public void Delete (int ComicID)
	{
		FavoriteComics favorites = (FavoriteComics)HttpContext.Current.Profile["Favorites"];
		if (favorites != null)
			favorites.RemoveComic (ComicID);
	}
}